//  ** Revision History **
//	950302		(AH) Value error for Toggled buttons fixed.
//	950118		(AH) VBTERMCC inlagd fr port till OCX
//  12-Jan-1993 (AH) (Release 1.0.0.000) 
//  11-Jan-1993 (AH) now supports VB2 help through F1
//  20-Dec-1992 (AH) Click event now is the last instruction, gives correct handling of Unload etc
//  29-Nov-1992 (AH) Draw3dtext moved to Eurotool.c
//  13-Nov-1992 (AH) Added support for Grey text when disabled
//  14-Oct-1992 (AH) Support for Keyboard added
//  14-Oct-1992 (AH) ColorBar added
//  04-Jul-1992 (AH) Group behaivior added
//  03-Jul-1992 (AH) FocusRectOn Property added now the Focus rectangel can be shutof
//  03-Jul-1992 (AH) About Dialogbox added
//  01-Jul-1992 (AH) Icon placement problem fixed.
//  30-Jun-1992 (AH) No 3D Border drawn if Look3D=TRUE and Width3D=0 
//  24-Jun-1992 (AH) Fire Change Event when Value Changed to TRUE
//  22-Jun-1992 (AH) Flyttat till PWB

//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:        PUSH.C         
//   
// PURPOSE:     Misc. control routines for Visual Basic
//   
// COMMENTS:    The Groundwork for Push is from Microsoft 
//   
// HISTORY:     920506AH Prehistory 
//   
//****************************************************************************                    

#define  NOCOMM
#include <windows.h>
#include <vbapi.h>
#include "..\eurotool.h"
#include "escmd.h"   

#include <string.h>
#define  CTL_DATA       // To declare static data in push.h
#include "push.h"
#include "vb1.h"		// Visual Basic 1.0 support
#include "vb2.h"		// Viusla Basic 2.0 support
#include "helpid.h"

//---------------------------------------------------------------------------
// Global Variables
//---------------------------------------------------------------------------
extern HANDLE hmodDLL;
extern WORD ipropDialog;
extern HCTL hctlDialog;  
extern USHORT VBVersion;
HANDLE  ghWndPush;              // handle for hWnd of Control

//---------------------------------------------------------------------------
// Local Prototypes
//---------------------------------------------------------------------------
VOID NEAR DrawBtn(HCTL hctl, LPDRAWITEMSTRUCT lpdi);
VOID NEAR RecalcAreaPush(HCTL hctl, HWND hWnd);

//**************************************************************************
//                        Copyright (C) 1992 EuroSource AB
//
//      FUNCTION:   LONG FAR PASCAL _export PushCtlProc(HCTL hctl, hWnd hWnd, 
//                                                      USHORT msg, USHORT wp, LONG lp)       
//
//      PURPOSE:    Control procedure for the PushButton Control.     
//
//      COMMENTS:        
//
//      HISTORY:    920506AH Prehistoric     
//
//**************************************************************************


LONG FAR PASCAL _export PushCtlProc(HCTL hctl, HWND hWnd, 
				    USHORT msg, USHORT wp, LONG lp)
{
    LONG        lResult;
    PPUSH       ppush;

    // Message pre-processing
    switch (msg)
    {
    case WM_CREATE:
		ppush = PUSHDEREF(hctl);
		ppush->Look3D = TRUE;
		ppush->Shadow = FALSE;
		ppush->Width3D = 2;
		ppush->BorderWidth = 0;
		ppush->ShadowWidth = 4;
		ppush->Light3DColor = WHITE;
		ppush->Dark3DColor = DARKGREY;
		ppush->BorderColor = GREY;
		ppush->ShadowColor = BLACK;
		ppush->ButtonStyle = STYLEINVERT3D;
		ppush->Toggle = FALSE;
		ppush->ToggleStatus = FALSE;
		ppush->AlignHoriz=HALIGNCENTER;
		ppush->AlignVert=VALIGNBOTTOM;
		ppush->Font3D=FONT3DNORMAL;
		ppush->FocusRect = TRUE;
			    
#ifndef RUNTIMEVERSION        
		// set the property text for the About dialog
		SetAboutText(hctl, IPROP_PUSH_ABOUT);
#endif  
		VBSetControlProperty(hctl, IPROP_PUSH_BACKCOLOR, 
				       PUSH_BACKGROUND_DEFAULT);    
		break;
	
    case WM_SIZE:
		RecalcAreaPush(hctl, hWnd);
		break;    
    
    case WM_SETFONT:
		ppush = PUSHDEREF(hctl);
		ppush->hfont = (HFONT)wp;
		return(0L);

    case WM_GETFONT:
		ppush = PUSHDEREF(hctl);
		return (ppush->hfont);

    case WM_SETTEXT:
    {
		HSZ hsz;

		ppush = PUSHDEREF(hctl);
		if (ppush->hszCaption) 
			VBDestroyHsz(ppush->hszCaption);
		hsz = VBCreateHsz((_segment)hctl, (LPSTR)lp);
		ppush = PUSHDEREF(hctl);
		ppush->hszCaption = hsz;
		ppush->CaptionLen=lstrlen(VBDerefHsz(ppush->hszCaption));
		InvalidateRect(hWnd, NULL, TRUE);
		return(0L);
     }
     
    case WM_GETTEXT:
    {    
		LPSTR   lpstr;
		WORD    cch;

		ppush = PUSHDEREF(hctl);
		if (ppush->hszCaption == NULL) 
		{
			*(LPSTR)lp = 0L;
			wp = 1;
		}
		else 
		{
			lpstr = VBDerefHsz(ppush->hszCaption);
			cch = lstrlen(lpstr) + 1;
			if (wp > cch)
				wp = cch;
			_fstrncpy((LPSTR)lp, lpstr, wp);
			((LPSTR)lp)[wp - 1] = '\0';
		}
    }
    return (LONG)(wp - 1);

    case WM_GETTEXTLENGTH:
		ppush = PUSHDEREF(hctl);
		if (ppush->hszCaption == NULL) 
		{
			ppush->CaptionLen=0;
			return(0L);
		}    
		else
			return (ppush->CaptionLen=lstrlen(VBDerefHsz(ppush->hszCaption)));
	    
    case BN_GROUPUP:
		ppush = PUSHDEREF(hctl);
		if (ppush->Group && ppush->Toggle)   
		{    
			if (ppush->GroupID == (SHORT)wp) 
	    	{
				// nothing done if already FALSE
				if (ppush->ToggleStatus) 
				{
					ppush->ToggleStatus = FALSE;
					InvalidateRect(hWnd, NULL, TRUE);
				}
			}
		}
		break;        

#ifndef RUNTIMEVERSION    		
    case WM_RBUTTONDBLCLK: 
	    if (VBGetMode() == MODE_DESIGN) 
		{
			WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, escommand);
			return OK;
	    }
	    else
			break;
#endif
    		      
    case WM_KEYDOWN: 
		if (wp != VK_SPACE)
			break;
		
	// **** if space fall through ****
    
    case WM_LBUTTONDBLCLK:
    case WM_LBUTTONDOWN: 
    {
		PPUSH   ppush;
	    
        GetFocus();
		ppush = PUSHDEREF(hctl);
		if (!ppush->Toggle) 
		{
			ppush->ToggleStatus = !ppush->ToggleStatus;
			InvalidateRect(hWnd, NULL, TRUE);
			break;
		}    
		else // here if toggled button
		{ 
			if (ppush->Group) 
	    	{
				FARPROC lpProcEnumButtons;
				BOOL    prestate=ppush->ToggleStatus;
	    
				lpProcEnumButtons = MakeProcInstance(EnumButtons,hmodDLL);
				EnumChildWindows(GetParent(hWnd), lpProcEnumButtons,
						 MAKELONG(ppush->GroupID, BN_GROUPUP));
				FreeProcInstance(lpProcEnumButtons);
				ppush->ToggleStatus = TRUE; 
				if (ppush->GroupAllUp) 
				ppush->ToggleStatus = !prestate;
				if (prestate != ppush->ToggleStatus)
					InvalidateRect(hWnd, NULL, TRUE);
			} 
			else
			{
				ppush->ToggleStatus = !ppush->ToggleStatus;
			}
			SendMessage(hWnd, VBN_COMMAND, 0, MAKELONG(0,BN_CLICKED));
			return (TRUE);
		}
		break;
    }  
    
    case WM_KEYUP: 
		if (wp != VK_SPACE)
			break;
		
	// **** if space fall through ****
    
    case WM_LBUTTONUP:  
    {
		PPUSH   ppush;
	
		ppush = PUSHDEREF(hctl);
		if (!ppush->Group) 
		{
			//ppush->ToggleStatus = !ppush->ToggleStatus;
			InvalidateRect(hWnd, NULL, TRUE);
		}    
		break;
    }
    
    case WM_ERASEBKGND:
		// Don't bother with erasing the background
		return TRUE;
	
    case VBM_MNEMONIC:
		// Act like a click
		lp = MAKELONG(0,BN_CLICKED);
    
	// **** FALL THROUGH ****

    case VBN_COMMAND:
		switch (HIWORD(lp)) 
		{
			case BN_CLICKED: 
	    	{
            	VBFireEvent(hctl, EVENT_PUSH_CLICK, NULL);
				break;
			}
		}    
	return 0L;

#ifndef RUNTIMEVERSION    
	case VBM_HELP:
	    switch (LOBYTE(wp))
		{
			case VBHELP_PROP:
		    	// High byte identifies which property.
		    	// Keyword is: "<property>"
		    	switch (HIBYTE(wp))
				{
					case IPROP_PUSH_ABOUT:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_about);
			    		return OK;

					case IPROP_PUSH_ALIGNHORIZ:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_aligntexthoriz);
			    		return 0L;                                                        
                
                	case IPROP_PUSH_ALIGNVERT:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_aligntextvert);
			    		return 0L; 
            	
                	case IPROP_PUSH_BORDERCOLOR:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_bordercolor);
			    		return 0L;                                            
            
            		case IPROP_PUSH_BORDERWIDTH:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_borderwidth);
			    		return 0L;                                            
            
            		case IPROP_PUSH_SMALLFACTOR:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_downscaling);
			    		return 0L;                                            
            
            		case IPROP_PUSH_DARK3DCOLOR:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_dark3dcolor);
			    		return 0L;                                            
            
            		case IPROP_PUSH_FOCUSRECTON:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_focusrecton);
			    		return 0L;                                            
            
            		case IPROP_PUSH_FONT3D:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_font3d);
			    		return 0L;                                       
            
            		case IPROP_PUSH_GROUP:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_group);
			    		return 0L;                                      
            
            		case IPROP_PUSH_GROUPALLUP:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_groupallup);
			    		return 0L;                                           
            
            		case IPROP_PUSH_GROUPID:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_groupid);
			    		return 0L;                                        
            
            		case IPROP_PUSH_LIGHT3DCOLOR:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_light3dcolor);
			    		return 0L;                                             
            
                	case IPROP_PUSH_LOOK3D:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_look3d);
			    		return 0L;                                             
                        
            		case IPROP_PUSH_PICTUREDOWN:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_picturedown);
			    		return 0L;                                             
                        
            		case IPROP_PUSH_PICTUREDISABLED:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_picturedisabled);
			    		return 0L;                                                
                    
                	case IPROP_PUSH_PICTUREUP:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_pictureup);
			    		return 0L;                                             
                        
            		case IPROP_PUSH_SHADOW:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_shadow);
			    		return 0L;                                       
                    
					case IPROP_PUSH_SHADOWCOLOR:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_shadowcolor);
			    		return 0L;                                             
                              
                	case IPROP_PUSH_SHADOWWIDTH:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_shadowwidth);
			    		return 0L;                                            
                     
                	case IPROP_PUSH_BUTTONSTYLE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_style);
			    		return 0L;                                      
                                                                             
                	case IPROP_PUSH_TOGGLE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_toggle);
			    		return 0L;
                
					case IPROP_PUSH_TOGGLESTATUS:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_value);
			    		return 0L;                                             
                               
                	case IPROP_PUSH_WIDTH3D:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_width3d);
			    		return 0L;                                             
				}
				break;

		case VBHELP_CTL:
		    // High byte is unused.
		    // Keyword is: "<classname>"
		    WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, escommand);;
		    return 0L;
	}
	break;

    case VBM_INITPROPPOPUP:
		switch (wp) 
		{
			case IPROP_PUSH_ABOUT:
				hctlDialog  = hctl;
				ipropDialog = wp;
				return (LONG)HwndInitAboutPopup();
				       
			case IPROP_PUSH_SHADOWCOLOR:
			case IPROP_PUSH_BORDERCOLOR:
			case IPROP_PUSH_DARK3DCOLOR:
			case IPROP_PUSH_LIGHT3DCOLOR:
				if (VBVersion < 0x0200) 
				{
					hctlDialog  = hctl;
					ipropDialog = wp;
					return (LONG)HwndInitColorPopup();
				}
		}
		break;
#endif
			 
    case VBM_SETPROPERTY:
		switch (wp) 
		{
			case IPROP_PUSH_CAPTION:
				// To avoid a Windows problem, make sure text is under 255 bytes:
				if (lstrlen((LPSTR)lp) > 255)
					*((LPSTR)lp + 255) = 0;
					break;  
	    
			case IPROP_PUSH_LOOK3D:    
			case IPROP_PUSH_WIDTH3D:
			case IPROP_PUSH_SHADOW:
			case IPROP_PUSH_BORDERWIDTH:
			case IPROP_PUSH_SHADOWWIDTH:
			case IPROP_PUSH_LIGHT3DCOLOR:
			case IPROP_PUSH_DARK3DCOLOR:
			case IPROP_PUSH_BORDERCOLOR:
			case IPROP_PUSH_SHADOWCOLOR:
			case IPROP_PUSH_TOGGLE:
			case IPROP_PUSH_ALIGNHORIZ:
			case IPROP_PUSH_ALIGNVERT:
			case IPROP_PUSH_FONT3D:   
					RecalcAreaPush(hctl, hWnd);
					InvalidateRect(hWnd, NULL, TRUE);
					return OK;   
	    
	    case IPROP_PUSH_TOGGLESTATUS:  
        	// redraw new status
            InvalidateRect(hWnd, NULL, TRUE);
			// Genereate Click Event if set to TRUE
            SendMessage(hWnd, VBN_COMMAND, 0, MAKELONG(0,BN_CLICKED));
			return OK;
	
		case IPROP_PUSH_GROUP:
			if (PUSHDEREF(hctl)->Group)
			PUSHDEREF(hctl)->Toggle = -1;
				return OK;      
	}
	break;

    case VBM_CHECKPROPERTY:
		switch (wp)
		{
			case IPROP_PUSH_PICTUREDISABLED:
			case IPROP_PUSH_PICTUREUP:
			case IPROP_PUSH_PICTUREDOWN: 
	    	{
				PIC pic;

				VBGetPic((HPIC)lp, &pic);
				switch (pic.picType) 
				{
					case PICTYPE_NONE:
					case PICTYPE_BITMAP:
					case PICTYPE_ICON:
					InvalidateRect(hWnd, NULL, TRUE);
					return ERR_None;
				}
				return ERR_InvPropVal;
			}
		}
		break;  
	
	case VBM_GETPROPERTY: 
    {
		ppush = PUSHDEREF(hctl);
	    
		if (wp == IPROP_PUSH_HWND) 
		{ 
			ghWndPush = VBGetControlHwnd(hctl);
			(HWND *)lp = &ghWndPush; 
			return OK;
		}   
		break; 
    }  
     
    case VBN_DRAWITEM:
		RecalcAreaPush(hctl, hWnd);
		DrawBtn(hctl, (LPDRAWITEMSTRUCT)lp);
		return(0);
}

    // Default processing:
    lResult = VBDefControlProc(hctl, hWnd, msg, wp, lp);

    // Message post-processing:
    switch (msg) 
    {
	case WM_DESTROY:
			VBFreePic(PUSHDEREF(hctl)->hpicDown);
			VBFreePic(PUSHDEREF(hctl)->hpicUp);
			VBFreePic(PUSHDEREF(hctl)->hpicDisabled);
			break;
    }
    return lResult;
}

//**************************************************************************
//                        Copyright (C) 1992 EuroSource AB
//
//      FUNCTION:   VOID NEAR DrawBtn(HCTL hctl, LPDRAWITEMSTRUCT lpdi)       
//
//      PURPOSE:    Draw the button in all its states.     
//
//      COMMENTS:        
//
//      HISTORY:    920506AH Prehistory     
//
//**************************************************************************

VOID NEAR DrawBtn(HCTL hctl, LPDRAWITEMSTRUCT lpdi)
{
    HPIC    hpic;
    PIC     pic;
    HANDLE  hBrush;
    HANDLE  hBrush3DLight,hBrush3DDark;
    HANDLE  hBrushShadow;
    HANDLE  hBrushBorder;
    HANDLE  hPenShadow;    
    HANDLE  hPenLight;      
    HANDLE  hPenDark;       
    HANDLE  hOldBrush = NULL;      
    HANDLE  hOldPen = NULL;
    HFONT   hOldFont = NULL;
    TEXTMETRIC  textMetric;
    PPUSH   ppush = PUSHDEREF(hctl);
    LPRECT  prect = &ppush->rectDrawInto;
    LPRECT  pirect = &ppush->rectInvert;
    LPRECT  prect3D = &ppush->rect3D;
    LPPOINT pointsLight = ppush->Point3DLight;
    LPPOINT pointsDark = ppush->Point3DDark;
    LPPOINT pointsShadow = ppush->PointShadow;
    RECT    rect;       
    BOOL    Shadow = ppush->Shadow;
    BOOL    invert=FALSE;
    BITMAP  bmp;
    HDC     hdcMem;
    SHORT   x,y;
    SHORT   selectflag=FALSE;
    BYTE    HorizontalAlignment,VerticalAlignment;
    SHORT   DownY=0,UpY=0,IconY=0;  
    BOOL    fEnabled;
    
    switch (lpdi->itemAction) 
    {
		case ODA_DRAWENTIRE:   
			// check if control is enabled
			VBGetControlProperty(hctl, IPROP_PUSH_ENABLED, (BOOL FAR *)&fEnabled);
	    
		selectflag = ppush->ToggleStatus;
		hOldFont = SelectObject(lpdi->hDC, ppush->hfont);
		GetTextMetrics(lpdi->hDC,&textMetric);
		if (ppush->CaptionLen != 0) 
	    {
				// Handle Horizontal Text Alignment
				switch(ppush->AlignHoriz) 
				{
				case    HALIGNLEFT:
						HorizontalAlignment=DT_LEFT;
						break;
	    
				case    HALIGNCENTER:
						HorizontalAlignment=DT_CENTER;
						break;
	    
				case    HALIGNRIGHT:
						HorizontalAlignment=DT_RIGHT;
						break;         
				}
				// Handle Vertical Alignment
				switch(ppush->AlignVert) 
				{
				case    VALIGNTOP:
						VerticalAlignment=DT_TOP;
						IconY=UpY=DownY=textMetric.tmHeight;
						break;
		
				case    VALIGNCENTER:
						VerticalAlignment=DT_VCENTER;
						break;        
	    
				case    VALIGNBOTTOM:
						VerticalAlignment=DT_BOTTOM;
						UpY=textMetric.tmHeight;
						IconY=-UpY;
						break;    
				}
		}
		// select disabled or up/down picture
	    
		// select up or down picture
		if (fEnabled)
				hpic = (selectflag) ? ppush->hpicDown : ppush->hpicUp;
		else
				hpic = ppush->hpicDisabled;
		    
		VBGetPic(hpic, &pic);
		if (pic.picType==PICTYPE_BITMAP) 
	    {
				GetObject(pic.picData.bmp.hbitmap, sizeof(BITMAP), (LPSTR)&bmp);
				hdcMem = CreateCompatibleDC(lpdi->hDC);
				SelectObject(hdcMem, pic.picData.bmp.hbitmap);
		}
	       
		// Should we invert 3D lines    
		if ((ppush->ButtonStyle==STYLEINVERT3D) || (ppush->ButtonStyle==STYLESHIFT))
				invert=TRUE;
	     
		hBrush = (HBRUSH)SendMessage(GetParent(lpdi->hwndItem), WM_CTLCOLOR, lpdi->hDC, 
					 MAKELONG(lpdi->hwndItem,0));
		//create pens                             
		hPenLight  = CreatePen(PS_SOLID,1, RGBCOLOR(ppush->Light3DColor)); 
		hPenDark   = CreatePen(PS_SOLID,1, RGBCOLOR(ppush->Dark3DColor));
		hPenShadow = CreatePen(PS_SOLID,1, RGBCOLOR(ppush->ShadowColor));
		// create brush's 
		hBrush3DLight = CreateSolidBrush(RGBCOLOR(ppush->Light3DColor));
		hBrush3DDark  = CreateSolidBrush(RGBCOLOR(ppush->Dark3DColor));
		hBrushShadow = CreateSolidBrush(RGBCOLOR(ppush->ShadowColor));
		hBrushBorder = CreateSolidBrush(RGBCOLOR(ppush->BorderColor));
		// Select new Pen & Brush
		hOldPen = SelectObject(lpdi->hDC, hPenLight);
		hOldBrush = SelectObject(lpdi->hDC, hBrush3DLight);
	    
		// Fill border
		FillRect(lpdi->hDC, &lpdi->rcItem, hBrushBorder);
		// Fill backgrund        
		FillRect(lpdi->hDC, prect, hBrush);
		
		x=prect->left;
		y=prect->top+DownY;
		if (pic.picType==PICTYPE_BITMAP) 
	    {
				StretchBlt(lpdi->hDC, x, y,prect->right - prect->left,
					prect->bottom - prect->top-UpY,
					hdcMem, 0, 0, bmp.bmWidth, bmp.bmHeight,
					SRCCOPY);
		}            
		if (pic.picType == PICTYPE_ICON) 
	    { 
				DrawIcon(lpdi->hDC,                               
					prect->left+(prect->right-prect->left-36)/2+2,
					prect->top+(prect->bottom-prect->top-36)/2+IconY/2+2,
					pic.picData.wmf.hmeta);
			}   
	    
		// Draw Light 3D part & toggle.
		if (ppush->Look3D && (ppush->Width3D != 0)) 
	    {
				if (!((ppush->ButtonStyle == STYLEREMOVE) && selectflag)) 
		{
				SelectObject(lpdi->hDC, (selectflag && invert) ? hBrush3DDark : hBrush3DLight);
				SelectObject(lpdi->hDC,(selectflag && invert) ? hPenDark : hPenLight);        
				Polygon(lpdi->hDC, pointsLight, 7);
				}
				// Draw Dark 3D part & toggle.
				//   Should NOT be drawn if Buttonstyle should be shifted down right
				if (!((ppush->ButtonStyle == STYLESHIFT) && selectflag)&&
				!((ppush->ButtonStyle == STYLEREMOVE) && selectflag)) 
		{
				SelectObject(lpdi->hDC, (selectflag && invert) ? hBrush3DLight : hBrush3DDark);
				SelectObject(lpdi->hDC,(selectflag && invert) ? hPenLight : hPenDark);
				Polygon(lpdi->hDC, pointsDark, 7);
				}
		}
		// Draw Shadow if one should be displayed
		if (!(ppush->ButtonStyle==STYLECOVER && selectflag)&&
			!(ppush->ButtonStyle==STYLEHALF && selectflag))
		{    
				SelectObject(lpdi->hDC, hBrushShadow);
				SelectObject(lpdi->hDC, hPenShadow);
				Polygon(lpdi->hDC, pointsShadow,7);
		}
	    
		// Draw Captiontext if it should be Displayed
		if (ppush->CaptionLen != 0) 
	    {
				SelectObject(lpdi->hDC, hBrush);
				DrawFont3D(lpdi->hDC, VBDerefHsz(ppush->hszCaption), prect,
					(HorizontalAlignment | VerticalAlignment | DT_SINGLELINE), ppush->Font3D, 
					TRANSPARENT, fEnabled ? GetTextColor(lpdi->hDC) : DARKGREY);
		}
				    
		// Invert all of the button if that buttonstyle
		if (selectflag && (ppush->ButtonStyle == STYLEINVERT))
				InvertRect(lpdi->hDC, pirect);
	    
		// Restore old objects
		SelectObject(lpdi->hDC, hOldFont);
		SelectObject(lpdi->hDC, hOldBrush); 
		SelectObject(lpdi->hDC, hOldPen);
	     
		// no need to delete hBrush (VB rescurce)
		DeleteObject(hPenShadow);
		DeleteObject(hPenLight);
		DeleteObject(hPenDark);
		DeleteObject(hBrush3DLight);
		DeleteObject(hBrush3DDark);   
		DeleteObject(hBrushShadow);     
		DeleteObject(hBrushBorder);
		if (pic.picType==PICTYPE_BITMAP) 
				DeleteDC(hdcMem);
		 
	// **** FALL THROUGH ****
   
	case ODA_FOCUS:
	    if (lpdi->itemState & ODS_FOCUS && PUSHDEREF(hctl)->FocusRect) 
	{
			GetClientRect(lpdi->hwndItem,&rect);
			InflateRect(&rect,-2,-2);
			DrawFocusRect(lpdi->hDC, &rect);
	    }   
	    break;
    }
}


//**************************************************************************
//                        Copyright (C) 1992 EuroSource AB
//
//      FUNCTION:   VOID NEAR RecalcAreaPush(HCTL hctl, HWND hWnd);      
//
//      PURPOSE:    Use the hWnd's client size to determine the bounding 
//                  rectangle for the buttonpicture and associated stuff.     
//
//      COMMENTS:        
//
//      HISTORY:    920511AH Prehistory     
//
//**************************************************************************


VOID NEAR RecalcAreaPush(HCTL hctl, HWND hWnd)
{
    PPUSH   ppush = PUSHDEREF(hctl);
    LPRECT  prect = &ppush->rectDrawInto;
    LPRECT  prectButton = &ppush->rectButton;
    LPRECT  pirect = &ppush->rectInvert;
    LPRECT  prect3D = &ppush->rect3D;
    RECT    prectALL;
    SHORT   Width3D = ppush->Width3D;           // 3D Width
    SHORT   BorderWidth = ppush->BorderWidth;   // width of border
    SHORT   ShadowWidth = ppush->ShadowWidth;   // width of shadow
    SHORT   narrow=0,downright=0,closer=0;
    
    // get the clientarea
    GetClientRect(hWnd, &prectALL);
    
    // check if 3D Look wanted
    if (!ppush->Look3D) 
		Width3D=0;
    
    // check if Shadow wanted
    if (!ppush->Shadow) 
		ShadowWidth=0;
    
    // if button should be shifted down/right we need to move
    // the picture down right with Width3D
    if (ppush->ButtonStyle == STYLESHIFT) 
    {
		if (ppush->ToggleStatus) 
	{
		downright=Width3D-1;
		}    
    }
    if ((ppush->ButtonStyle == STYLESMALLER) && ppush->ToggleStatus) 
    {
		prectALL.left += ppush->SmallFactor;
		prectALL.top += ppush->SmallFactor;
		prectALL.right -= ppush->SmallFactor;
		prectALL.bottom -= ppush->SmallFactor;
    }    
    if ((ppush->ButtonStyle == STYLE13) && ppush->ToggleStatus) 
    {
		prectALL.left += ShadowWidth/3;
		prectALL.top += ShadowWidth/3;
		prectALL.right += ShadowWidth/3;
		prectALL.bottom += ShadowWidth/3;
		closer = ShadowWidth/3;
    }
    if ((ppush->ButtonStyle == STYLEHALF) && ppush->ToggleStatus) 
    {
		prectALL.left += ShadowWidth/2;
		prectALL.top += ShadowWidth/2;
		prectALL.right += ShadowWidth/2;
		prectALL.bottom += ShadowWidth/2;
		closer = ShadowWidth/2;
    }
    if ((ppush->ButtonStyle == STYLECOVER) && ppush->ToggleStatus) 
    {
		prectALL.left += ShadowWidth;
		prectALL.top += ShadowWidth;
		prectALL.right += ShadowWidth;
		prectALL.bottom += ShadowWidth;
    }   
	
    // calculate the window to display button picture in 
    prect->left  = prectALL.left+Width3D+BorderWidth+downright;
    prect->right = prectALL.right-Width3D-BorderWidth-ShadowWidth+downright;
    prect->bottom = prectALL.bottom-Width3D-BorderWidth-ShadowWidth+downright;
    prect->top   = prectALL.top+Width3D+BorderWidth+downright;
    
    prect3D->left = prect->left+1;
    prect3D->right = prect->right+1;
    prect3D->bottom = prect->bottom+1;
    prect3D->top = prect->top+1;
    
    // check if Width3D should be narrowed
    // ** MUST ** be here to keep picture proportions
    if (ppush->ButtonStyle == STYLETHICKNESS) 
    {
		if (ppush->ToggleStatus)
		narrow = Width3D/2;
    }
    if (ppush->ButtonStyle == STYLEREMOVE) 
    {
		if (ppush->ToggleStatus)
		narrow = Width3D;
    }
    
    // calculate the window to display inverted button picture in 
    pirect->left  = prectALL.left+BorderWidth;
    pirect->right = prectALL.right-BorderWidth-ShadowWidth;
    pirect->bottom = prectALL.bottom-BorderWidth-ShadowWidth;
    pirect->top   = prectALL.top+BorderWidth;
    
    // set points for 3D polygon Light
    ppush->Point3DLight[0].x = prectALL.left+BorderWidth;  
    ppush->Point3DLight[0].y = prectALL.bottom-BorderWidth-ShadowWidth;
	
    ppush->Point3DLight[1].x = prect->left-narrow-downright-1;      
    ppush->Point3DLight[1].y = prect->bottom+narrow+1;
	
    ppush->Point3DLight[2].x = prect->left-narrow-downright-1;
    ppush->Point3DLight[2].y = prect->top-narrow-downright-1;
	
    ppush->Point3DLight[3].x = prect->right+narrow+1;
    ppush->Point3DLight[3].y = prect->top-narrow-downright-1;
	
    ppush->Point3DLight[4].x = prectALL.right-BorderWidth-ShadowWidth;
    ppush->Point3DLight[4].y = prectALL.top+BorderWidth;
	
    ppush->Point3DLight[5].x = prectALL.left+BorderWidth;
    ppush->Point3DLight[5].y = prectALL.top+BorderWidth;
	
    ppush->Point3DLight[6].x = prectALL.left+BorderWidth;
    ppush->Point3DLight[6].y = prectALL.bottom-BorderWidth-ShadowWidth;     
    
    // set points for 3D polygon Dark
    ppush->Point3DDark[0].x = prectALL.left+BorderWidth;  
    ppush->Point3DDark[0].y = prectALL.bottom-BorderWidth-ShadowWidth ;
	
    ppush->Point3DDark[1].x = prect->left-narrow;      
    ppush->Point3DDark[1].y = prect->bottom+narrow;
	
    ppush->Point3DDark[2].x = prect->right+narrow;
    ppush->Point3DDark[2].y = prect->bottom+narrow;
	
    ppush->Point3DDark[3].x = prect->right+narrow;
    ppush->Point3DDark[3].y = prect->top-narrow;
	
    ppush->Point3DDark[4].x = prectALL.right-BorderWidth-ShadowWidth;
    ppush->Point3DDark[4].y = prectALL.top+BorderWidth;
	
    ppush->Point3DDark[5].x = prectALL.right-BorderWidth-ShadowWidth;
    ppush->Point3DDark[5].y = prectALL.bottom-BorderWidth-ShadowWidth;
	
    ppush->Point3DDark[6].x = prectALL.left+BorderWidth;
    ppush->Point3DDark[6].y = prectALL.bottom-BorderWidth-ShadowWidth;
    
    ShadowWidth -= 1;
    // set points for Shadow
    ppush->PointShadow[0].x = prectALL.left+ShadowWidth;  
    ppush->PointShadow[0].y = prectALL.bottom-ShadowWidth;
	
    ppush->PointShadow[1].x = prectALL.left+ShadowWidth;      
    ppush->PointShadow[1].y = prectALL.bottom+closer;
	
    ppush->PointShadow[2].x = prectALL.right-closer;
    ppush->PointShadow[2].y = prectALL.bottom+closer;
	
    ppush->PointShadow[3].x = prectALL.right-closer;
    ppush->PointShadow[3].y = prectALL.top+ShadowWidth;
	
    ppush->PointShadow[4].x = prectALL.right-ShadowWidth;
    ppush->PointShadow[4].y = prectALL.top+ShadowWidth;
	
    ppush->PointShadow[5].x = prectALL.right-ShadowWidth;
    ppush->PointShadow[5].y = prectALL.bottom-ShadowWidth;
	
    ppush->PointShadow[6].x = prectALL.left+ShadowWidth;
    ppush->PointShadow[6].y = prectALL.bottom-ShadowWidth;
}    
