//  ** Revision History **
//  30-Jun-1992 (AH) Look3D CheckMsg changed to SetMsg
//**************************************************************************
//                        Copyright (C) 1992 EuroSource AB
//
//      FILE:           PUSH.H       
//
//      PURPOSE:        Header for EuroTools PUSH subclass. 
//
//      COMMENTS:        
//
//      HISTORY:         920525AH Prehistory
//
//**************************************************************************

#define PUSH_BACKGROUND_DEFAULT GREY

// Buttonstyles
#define STYLENOEFFECT   0
#define STYLEINVERT     1
#define STYLEINVERT3D   2
#define STYLETHICKNESS  3
#define STYLEREMOVE     4
#define STYLESHIFT      5
#define STYLECOVER      6
#define STYLE13         7
#define STYLEHALF       8
#define STYLESMALLER    9

//---------------------------------------------------------------------------
// PUSH control data and structs
//---------------------------------------------------------------------------
typedef struct tagPUSH
{
    // Picture
    PRECT   ppict;          // drawing area for the picture.
    HPIC    hpicUp;         // Handle for 'up' picture.
    HPIC    hpicDown;       // Handle for 'down' picture.
    HPIC    hpicDisabled;	// Handle for 'disabled' picture
    HFONT   hfont;          // Handle to Caption font
    HSZ     hszCaption;     // Handle to Caption String
    SHORT   CaptionLen;     // Length for Caption String
    // apperance
    BOOL    Look3D;         // TRUE if 3D look
    SHORT   Width3D;        // Width for 3D border.
    SHORT   ShadowWidth;    // Width for possible Shadow
    POINT   Point3DLight[7]; // Points for 3D area Light.
    POINT   Point3DDark[7]; // Points for 3D area Dark
    POINT   PointShadow[7]; // Points for Shadow effect
    SHORT   BorderWidth;    // Width for border:
    BOOL    Shadow;         // TRUE if Shadow
    ENUM    ButtonStyle;    // Style for the button.
    RECT    rectDrawInto;   // The buttonpicture is in this rectangle
    RECT    rectButton;     // The button with 3D effects is in this rectangle
    RECT    rectInvert;     // Rectangle to Invert (if enabled),
    RECT    rect3D;         // rectangle for 3D text white part
    RECT    rect3DHeavy;    // rectangle for 3D text DarkGrey part
    LONG    Light3DColor;   // Color for light part of 3D border
    LONG    Dark3DColor;    // Color for dark part of 3D border
    LONG    BorderColor;    // Color for border around button
    LONG    ShadowColor;    // Color for Shadow 
    BOOL    ToggleStatus;   // Status for the button
    BOOL    Toggle;         // True if button should be toggled
    ENUM    AlignHoriz;     // Horozontal alignment of text;
    ENUM    AlignVert;      // Vertical alignment of text;
    SHORT   SmallFactor;    // units to make smaller
    ENUM    Font3D;         // different types of 3D text
    HSZ		hszabout; 
	BOOL	FocusRect;		// TRUE if focusrectangle should be shown 
	BOOL	Group;			// TRUE if button grouped
	SHORT	GroupID;		// GroupID
	BOOL	GroupAllUp;		// TRUE if all buttons allowed up simultaniously
} PUSH;

typedef PUSH FAR * PPUSH;

#define PUSHDEREF(hctl)     ((PPUSH)VBDerefControl(hctl))


//---------------------------------------------------------------------------
// Control Procedure
//---------------------------------------------------------------------------
LONG FAR PASCAL _export PushCtlProc(HCTL, HWND, USHORT, USHORT, LONG);


#ifndef RC_INVOKED
//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------
#define IPROP_PUSH_NAME         0
#define IPROP_PUSH_INDEX        1
#define IPROP_PUSH_PARENT       2
#define IPROP_PUSH_BACKCOLOR    3
#define IPROP_PUSH_LEFT         4
#define IPROP_PUSH_TOP          5
#define IPROP_PUSH_WIDTH        6
#define IPROP_PUSH_HEIGHT       7
#define IPROP_PUSH_ENABLED      8
#define IPROP_PUSH_VISIBLE      9
#define IPROP_PUSH_MOUSEPOINTER 10
#define IPROP_PUSH_CAPTION      11
#define IPROP_PUSH_FONTNAME     12
#define IPROP_PUSH_FONTSIZE     13
#define IPROP_PUSH_FONTBOLD     14
#define IPROP_PUSH_FONTITALIC   15
#define IPROP_PUSH_FONTSTRIKE   16
#define IPROP_PUSH_FONTUNDER    17
#define IPROP_PUSH_DRAG         18
#define IPROP_PUSH_DRAGICON     19
#define IPROP_PUSH_TABINDEX     20
#define IPROP_PUSH_TABSTOP      21
#define IPROP_PUSH_TAG          22
#define IPROP_PUSH_PICTUREUP    23
#define IPROP_PUSH_PICTUREDOWN  24
#define IPROP_PUSH_BORDERON     25
#define IPROP_PUSH_LOOK3D       26
#define IPROP_PUSH_WIDTH3D      27
#define IPROP_PUSH_SHADOW       28
#define IPROP_PUSH_BORDERWIDTH  29
#define IPROP_PUSH_SHADOWWIDTH  30
#define IPROP_PUSH_LIGHT3DCOLOR 31
#define IPROP_PUSH_DARK3DCOLOR  32
#define IPROP_PUSH_BORDERCOLOR  33
#define IPROP_PUSH_SHADOWCOLOR  34
#define IPROP_PUSH_TOGGLESTATUS 35
#define IPROP_PUSH_TOGGLE       36
#define IPROP_PUSH_BUTTONSTYLE  37
#define IPROP_PUSH_FORECOLOR    38
#define IPROP_PUSH_ALIGNHORIZ   39
#define IPROP_PUSH_ALIGNVERT    40
#define IPROP_PUSH_SMALLFACTOR  41
#define IPROP_PUSH_FONT3D       42
#define IPROP_PUSH_ABOUT		43
#define IPROP_PUSH_FOCUSRECTON  44
#define IPROP_PUSH_GROUP	    45
#define IPROP_PUSH_GROUPID	    46
#define IPROP_PUSH_GROUPALLUP	47
#define IPROP_PUSH_PICTUREDISABLED	48
#define IPROP_PUSH_HWND			49

#ifdef CTL_DATA

PROPINFO Property_Push_About =
{
    "About...",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fEditable,
    OFFSETIN(PUSH, hszabout), 
};      

PROPINFO propinfoPushPictureUp =
{
    "PictureUp",
    DT_PICTURE | PF_fGetData | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(PUSH,hpicUp), 0,
	0
};

PROPINFO propinfoPushPictureDown =
{
    "PictureDown",
    DT_PICTURE | PF_fGetData | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(PUSH,hpicDown), 0,
	0
};

PROPINFO propinfoPushPictureDisabled =
{
    "PictureDisabled",
    DT_PICTURE | PF_fGetData | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(PUSH,hpicDisabled), 0,
	0
};
 
PROPINFO propinfoPushLook3D =
{
    "Look3D",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(PUSH,Look3D), 0,
	TRUE
};

PROPINFO propinfoPushWidth3D =
{
    "Width3D",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(PUSH,Width3D), 0,
	2
};

PROPINFO propinfoPushShadow =
{
    "Shadow",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(PUSH,Shadow), 0,
	FALSE
};

PROPINFO propinfoPushBorderWidth =
{
    "BorderWidth",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(PUSH,BorderWidth), 0,
	0
};

PROPINFO propinfoPushShadowWidth =
{
    "ShadowWidth",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(PUSH,ShadowWidth), 0,
	4
};

PROPINFO propinfoPushLight3DColor =
{
    "Light3DColor",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fEditable | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(PUSH,Light3DColor), 0,
	WHITE
};

PROPINFO propinfoPushDark3DColor =
{
    "Dark3DColor",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fEditable | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(PUSH,Dark3DColor), 0,
	DARKGREY
};

PROPINFO propinfoPushBorderColor =
{
    "BorderColor",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fEditable | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(PUSH,BorderColor), 0,
	GREY
};

PROPINFO propinfoPushShadowColor =
{
    "ShadowColor",
    DT_COLOR | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fEditable | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(PUSH,ShadowColor), 0,
	BLACK
};

PROPINFO propinfoPushToggleStatus =
{
    "Value",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(PUSH,ToggleStatus), 0,
	FALSE
};

PROPINFO propinfoPushToggle =
{
    "Toggle",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(PUSH,Toggle), 0,
	FALSE
};

PROPINFO propinfoPushButtonStyle =
{
    "Style",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(PUSH,ButtonStyle), 0,
    STYLEINVERT3D,
    "0 - No effect.\0"
    "1 - Invert all button colors.\0"
    "2 - Invert 3D-border Colors.\0"
    "3 - Half 3D thickness.\0"
    "4 - Remove 3D lines.\0"
    "5 - Shift symbol down/right.\0"
    "6 - Shadow: Button covers Shadow.\0"
    "7 - Shadow: Button & Shadow move closer.\0"
    "8 - Shadow: Button & Shadow meet halfways.\0"
    "9 - Make button smaller when selected.\0",
    STYLESMALLER
};

PROPINFO propinfoPushAlignHoriz =
{
    "AlignTextHoriz",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(PUSH,AlignHoriz), 0,
    HALIGNCENTER,
    "0 - Left.\0"
    "1 - Center.\0"
    "2 - Right.\0",
    HALIGNRIGHT
};

PROPINFO propinfoPushAlignVert =
{
    "AlignTextVert",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(PUSH,AlignVert), 0,
    VALIGNBOTTOM,
    "0 - At Top.\0"
    "1 - Vertical Center.\0"
    "2 - At Bottom.\0",
    VALIGNBOTTOM
};


PROPINFO propinfoPushSmallFactor =
{
    "DownScaling",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(PUSH,SmallFactor), 0,
	0
};

PROPINFO propinfoPushFont3D =
{
    "Font3D",
    DT_ENUM | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(PUSH,Font3D), 0,
    FONT3DNORMAL,
    "0 - Normal Text.\0"
    "1 - Carved light.\0"
    "2 - Carved Heavy.\0"
    "3 - Raised light.\0"
    "4 - Raised Heavy.\0",
    FONT3DRAISEDHEAVY
};

PROPINFO propinfoPushFocusRect =
{
    "FocusRectOn",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(PUSH,FocusRect), 0,
	TRUE
};

PROPINFO propinfoPushGroup =
{
    "Group",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(PUSH,Group), 0,
	FALSE
};

PROPINFO propinfoPushGroupID =
{
    "GroupID",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(PUSH,GroupID), 0,
	0
};
    
PROPINFO propinfoPushGroupAllUp =
{
    "GroupAllUp",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(PUSH,GroupAllUp), 0,
	FALSE
};

PROPINFO propinfoPushhWnd =
{
    "hWnd",
    DT_SHORT | PF_fGetMsg | PF_fNoShow | PF_fNoRuntimeW,
    0, 0
}; 

PPROPINFO proplistPush[] =
{
    PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_INDEX,
    PPROPINFO_STD_PARENT,
    PPROPINFO_STD_BACKCOLOR,
    PPROPINFO_STD_LEFT,
    PPROPINFO_STD_TOP,
    PPROPINFO_STD_WIDTH,
    PPROPINFO_STD_HEIGHT,
    PPROPINFO_STD_ENABLED,
    PPROPINFO_STD_VISIBLE,
    PPROPINFO_STD_MOUSEPOINTER,
    PPROPINFO_STD_CAPTION,
    PPROPINFO_STD_FONTNAME,
    PPROPINFO_STD_FONTSIZE,
    PPROPINFO_STD_FONTBOLD,
    PPROPINFO_STD_FONTITALIC,
    PPROPINFO_STD_FONTSTRIKE,
    PPROPINFO_STD_FONTUNDER,
    PPROPINFO_STD_DRAGMODE,
    PPROPINFO_STD_DRAGICON,
    PPROPINFO_STD_TABINDEX,
    PPROPINFO_STD_TABSTOP,
    PPROPINFO_STD_TAG,
    &propinfoPushPictureUp,
    &propinfoPushPictureDown,
    PPROPINFO_STD_BORDERSTYLEON,
    &propinfoPushLook3D,
    &propinfoPushWidth3D,
    &propinfoPushShadow,
    &propinfoPushBorderWidth,
    &propinfoPushShadowWidth,
    &propinfoPushLight3DColor,
    &propinfoPushDark3DColor,
    &propinfoPushBorderColor,
    &propinfoPushShadowColor,
    &propinfoPushToggleStatus,
    &propinfoPushToggle,
    &propinfoPushButtonStyle,
    PPROPINFO_STD_FORECOLOR,
    &propinfoPushAlignHoriz,
    &propinfoPushAlignVert,
    &propinfoPushSmallFactor,
    &propinfoPushFont3D,
    &Property_Push_About,
    &propinfoPushFocusRect,
    &propinfoPushGroup,
    &propinfoPushGroupID,
    &propinfoPushGroupAllUp,
    &propinfoPushPictureDisabled,
    &propinfoPushhWnd,
    NULL
};
#endif  // CTL_DATA

//---------------------------------------------------------------------------
// Event list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the events
//---------------------------------------------------------------------------
#define EVENT_PUSH_CLICK        0
#define EVENT_PUSH_DRAGDROP     1
#define EVENT_PUSH_DRAGOVER     2
#define EVENT_PUSH_GOTFOCUS     3
#define EVENT_PUSH_KEYDOWN      4
#define EVENT_PUSH_KEYPRESS     5
#define EVENT_PUSH_KEYUP        6
#define EVENT_PUSH_LOSTFOCUS    7

#ifdef CTL_DATA
PEVENTINFO eventlistPush[] =
{
    PEVENTINFO_STD_CLICK,
    PEVENTINFO_STD_DRAGDROP,
    PEVENTINFO_STD_DRAGOVER,
    PEVENTINFO_STD_GOTFOCUS,
    PEVENTINFO_STD_KEYDOWN,
    PEVENTINFO_STD_KEYPRESS,
    PEVENTINFO_STD_KEYUP,
    PEVENTINFO_STD_LOSTFOCUS,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------
#ifdef CTL_DATA
MODEL modelPush =
{                                                           
    VB_VERSION,                     // VB version being used
    MODEL_fDesInteract | MODEL_fFocusOk | MODEL_fMnemonic,   // MODEL flags
    (PCTLPROC)PushCtlProc,          // Control procedure
    CS_VREDRAW | CS_HREDRAW,        // Class style
    BS_PUSHBUTTON | BS_OWNERDRAW |	// Default Window style
    WS_BORDER,
    sizeof(PUSH),           	// cbCtlExtra for PUSH structure
    IDBMP_PUSH,             	// Palette bitmap ID
    "EsCommand",	    		// Default control name
    "EsCommand",	    		// Visual Basic class name
    "Button",               	// Parent class name
    proplistPush,           	// Properties list
    eventlistPush,           	// Events list
	IPROP_PUSH_TOGGLESTATUS, 	// default property in code window : Value
	EVENT_PUSH_CLICK			// default event in code window
};
#endif  // CTL_DATA

LPMODEL modellistPush[] =
    {
    &modelPush,
    NULL
    };

MODELINFO modelinfoPush =
    {
    VB_VERSION, 			// VB version being used
    modellistPush			// MODEL list
    };           
    
#endif  // RC_INVOKED
  
